// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_CONTENT_CAPTURE_COMMON_CONTENT_CAPTURE_MOJOM_TEST_UTILS_H_
#define COMPONENTS_CONTENT_CAPTURE_COMMON_CONTENT_CAPTURE_MOJOM_TEST_UTILS_H_

#include "components/content_capture/common/content_capture.mojom.h"


namespace content_capture {
namespace mojom {


class  ContentCaptureReceiverInterceptorForTesting : public ContentCaptureReceiver {
  virtual ContentCaptureReceiver* GetForwardingInterface() = 0;
  void DidCaptureContent(const content_capture::ContentCaptureData& data, bool first_data) override;
  void DidRemoveContent(const std::vector<int64_t>& ids) override;
};
class  ContentCaptureReceiverAsyncWaiter {
 public:
  explicit ContentCaptureReceiverAsyncWaiter(ContentCaptureReceiver* proxy);
  ~ContentCaptureReceiverAsyncWaiter();

 private:
  ContentCaptureReceiver* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ContentCaptureReceiverAsyncWaiter);
};




}  // namespace mojom
}  // namespace content_capture

#endif  // COMPONENTS_CONTENT_CAPTURE_COMMON_CONTENT_CAPTURE_MOJOM_TEST_UTILS_H_