// This file is generated by TypeBuilder_h.template.

// Copyright (c) 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef content_protocol_BackgroundService_h
#define content_protocol_BackgroundService_h

#include "content/common/content_export.h"
#include "content/browser/devtools/protocol/protocol.h"
// For each imported domain we generate a ValueConversions struct instead of a full domain definition
// and include Domain::API version from there.

namespace content {
namespace protocol {
namespace BackgroundService {

// ------------- Forward and enum declarations.
using ServiceName = String;
class RecordingStateChangedNotification;

namespace ServiceNameEnum {
CONTENT_EXPORT extern const char BackgroundFetch[];
CONTENT_EXPORT extern const char BackgroundSync[];
} // namespace ServiceNameEnum

// ------------- Type and builder declarations.

class CONTENT_EXPORT RecordingStateChangedNotification : public Serializable{
    PROTOCOL_DISALLOW_COPY(RecordingStateChangedNotification);
public:
    static std::unique_ptr<RecordingStateChangedNotification> fromValue(protocol::Value* value, ErrorSupport* errors);

    ~RecordingStateChangedNotification() override { }

    bool GetIsRecording() { return m_isRecording; }
    void SetIsRecording(bool value) { m_isRecording = value; }

    String GetService() { return m_service; }
    void SetService(const String& value) { m_service = value; }

    std::unique_ptr<protocol::DictionaryValue> toValue() const;
    String serializeToJSON() override { return toValue()->serializeToJSON(); }
    std::vector<uint8_t> serializeToBinary() override { return toValue()->serializeToBinary(); }
    String toJSON() const { return toValue()->toJSONString(); }
    std::unique_ptr<RecordingStateChangedNotification> clone() const;

    template<int STATE>
    class RecordingStateChangedNotificationBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            IsRecordingSet = 1 << 1,
            ServiceSet = 1 << 2,
            AllFieldsSet = (IsRecordingSet | ServiceSet | 0)};


        RecordingStateChangedNotificationBuilder<STATE | IsRecordingSet>& SetIsRecording(bool value)
        {
            static_assert(!(STATE & IsRecordingSet), "property isRecording should not be set yet");
            m_result->SetIsRecording(value);
            return castState<IsRecordingSet>();
        }

        RecordingStateChangedNotificationBuilder<STATE | ServiceSet>& SetService(const String& value)
        {
            static_assert(!(STATE & ServiceSet), "property service should not be set yet");
            m_result->SetService(value);
            return castState<ServiceSet>();
        }

        std::unique_ptr<RecordingStateChangedNotification> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class RecordingStateChangedNotification;
        RecordingStateChangedNotificationBuilder() : m_result(new RecordingStateChangedNotification()) { }

        template<int STEP> RecordingStateChangedNotificationBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<RecordingStateChangedNotificationBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::BackgroundService::RecordingStateChangedNotification> m_result;
    };

    static RecordingStateChangedNotificationBuilder<0> Create()
    {
        return RecordingStateChangedNotificationBuilder<0>();
    }

private:
    RecordingStateChangedNotification()
    {
          m_isRecording = false;
    }

    bool m_isRecording;
    String m_service;
};


// ------------- Backend interface.

class CONTENT_EXPORT Backend {
public:
    virtual ~Backend() { }

    virtual DispatchResponse Enable(const String& in_service) = 0;
    virtual DispatchResponse Disable(const String& in_service) = 0;
    virtual DispatchResponse SetRecording(bool in_shouldRecord, const String& in_service) = 0;

};

// ------------- Frontend interface.

class CONTENT_EXPORT Frontend {
public:
    explicit Frontend(FrontendChannel* frontendChannel) : m_frontendChannel(frontendChannel) { }
    void RecordingStateChanged(bool isRecording, const String& service);

    void flush();
    void sendRawNotification(String);
    void sendRawNotification(std::vector<uint8_t>);
private:
    FrontendChannel* m_frontendChannel;
};

// ------------- Dispatcher.

class CONTENT_EXPORT Dispatcher {
public:
    static void wire(UberDispatcher*, Backend*);

private:
    Dispatcher() { }
};

// ------------- Metainfo.

class CONTENT_EXPORT Metainfo {
public:
    using BackendClass = Backend;
    using FrontendClass = Frontend;
    using DispatcherClass = Dispatcher;
    static const char domainName[];
    static const char commandPrefix[];
    static const char version[];
};

} // namespace BackgroundService
} // namespace content
} // namespace protocol

#endif // !defined(content_protocol_BackgroundService_h)
