// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MEDIA_MOJO_INTERFACES_JPEG_ENCODE_ACCELERATOR_MOJOM_PARAMS_DATA_H_
#define MEDIA_MOJO_INTERFACES_JPEG_ENCODE_ACCELERATOR_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace media {
namespace mojom {
namespace internal {
class  JpegEncodeAccelerator_Initialize_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(JpegEncodeAccelerator_Initialize_Params_Data));
      new (data()) JpegEncodeAccelerator_Initialize_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    JpegEncodeAccelerator_Initialize_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<JpegEncodeAccelerator_Initialize_Params_Data>(index_);
    }
    JpegEncodeAccelerator_Initialize_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  JpegEncodeAccelerator_Initialize_Params_Data();
  ~JpegEncodeAccelerator_Initialize_Params_Data() = delete;
};
static_assert(sizeof(JpegEncodeAccelerator_Initialize_Params_Data) == 8,
              "Bad sizeof(JpegEncodeAccelerator_Initialize_Params_Data)");
class  JpegEncodeAccelerator_Initialize_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(JpegEncodeAccelerator_Initialize_ResponseParams_Data));
      new (data()) JpegEncodeAccelerator_Initialize_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    JpegEncodeAccelerator_Initialize_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<JpegEncodeAccelerator_Initialize_ResponseParams_Data>(index_);
    }
    JpegEncodeAccelerator_Initialize_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  JpegEncodeAccelerator_Initialize_ResponseParams_Data();
  ~JpegEncodeAccelerator_Initialize_ResponseParams_Data() = delete;
};
static_assert(sizeof(JpegEncodeAccelerator_Initialize_ResponseParams_Data) == 16,
              "Bad sizeof(JpegEncodeAccelerator_Initialize_ResponseParams_Data)");
class  JpegEncodeAccelerator_EncodeWithFD_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(JpegEncodeAccelerator_EncodeWithFD_Params_Data));
      new (data()) JpegEncodeAccelerator_EncodeWithFD_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    JpegEncodeAccelerator_EncodeWithFD_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<JpegEncodeAccelerator_EncodeWithFD_Params_Data>(index_);
    }
    JpegEncodeAccelerator_EncodeWithFD_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t buffer_id;
  mojo::internal::Handle_Data input_fd;
  uint32_t input_buffer_size;
  int32_t coded_size_width;
  int32_t coded_size_height;
  mojo::internal::Handle_Data exif_fd;
  uint32_t exif_buffer_size;
  mojo::internal::Handle_Data output_fd;
  uint32_t output_buffer_size;
  uint8_t padfinal_[4];

 private:
  JpegEncodeAccelerator_EncodeWithFD_Params_Data();
  ~JpegEncodeAccelerator_EncodeWithFD_Params_Data() = delete;
};
static_assert(sizeof(JpegEncodeAccelerator_EncodeWithFD_Params_Data) == 48,
              "Bad sizeof(JpegEncodeAccelerator_EncodeWithFD_Params_Data)");
class  JpegEncodeAccelerator_EncodeWithFD_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(JpegEncodeAccelerator_EncodeWithFD_ResponseParams_Data));
      new (data()) JpegEncodeAccelerator_EncodeWithFD_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    JpegEncodeAccelerator_EncodeWithFD_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<JpegEncodeAccelerator_EncodeWithFD_ResponseParams_Data>(index_);
    }
    JpegEncodeAccelerator_EncodeWithFD_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t buffer_id;
  uint32_t encoded_buffer_size;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  JpegEncodeAccelerator_EncodeWithFD_ResponseParams_Data();
  ~JpegEncodeAccelerator_EncodeWithFD_ResponseParams_Data() = delete;
};
static_assert(sizeof(JpegEncodeAccelerator_EncodeWithFD_ResponseParams_Data) == 24,
              "Bad sizeof(JpegEncodeAccelerator_EncodeWithFD_ResponseParams_Data)");

}  // namespace internal
class JpegEncodeAccelerator_Initialize_ParamsDataView {
 public:
  JpegEncodeAccelerator_Initialize_ParamsDataView() {}

  JpegEncodeAccelerator_Initialize_ParamsDataView(
      internal::JpegEncodeAccelerator_Initialize_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::JpegEncodeAccelerator_Initialize_Params_Data* data_ = nullptr;
};

class JpegEncodeAccelerator_Initialize_ResponseParamsDataView {
 public:
  JpegEncodeAccelerator_Initialize_ResponseParamsDataView() {}

  JpegEncodeAccelerator_Initialize_ResponseParamsDataView(
      internal::JpegEncodeAccelerator_Initialize_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool success() const {
    return data_->success;
  }
 private:
  internal::JpegEncodeAccelerator_Initialize_ResponseParams_Data* data_ = nullptr;
};

class JpegEncodeAccelerator_EncodeWithFD_ParamsDataView {
 public:
  JpegEncodeAccelerator_EncodeWithFD_ParamsDataView() {}

  JpegEncodeAccelerator_EncodeWithFD_ParamsDataView(
      internal::JpegEncodeAccelerator_EncodeWithFD_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t buffer_id() const {
    return data_->buffer_id;
  }
  mojo::ScopedHandle TakeInputFd() {
    mojo::ScopedHandle result;
    bool ret =
        mojo::internal::Deserialize<mojo::ScopedHandle>(
            &data_->input_fd, &result, context_);
    DCHECK(ret);
    return result;
  }
  uint32_t input_buffer_size() const {
    return data_->input_buffer_size;
  }
  int32_t coded_size_width() const {
    return data_->coded_size_width;
  }
  int32_t coded_size_height() const {
    return data_->coded_size_height;
  }
  mojo::ScopedHandle TakeExifFd() {
    mojo::ScopedHandle result;
    bool ret =
        mojo::internal::Deserialize<mojo::ScopedHandle>(
            &data_->exif_fd, &result, context_);
    DCHECK(ret);
    return result;
  }
  uint32_t exif_buffer_size() const {
    return data_->exif_buffer_size;
  }
  mojo::ScopedHandle TakeOutputFd() {
    mojo::ScopedHandle result;
    bool ret =
        mojo::internal::Deserialize<mojo::ScopedHandle>(
            &data_->output_fd, &result, context_);
    DCHECK(ret);
    return result;
  }
  uint32_t output_buffer_size() const {
    return data_->output_buffer_size;
  }
 private:
  internal::JpegEncodeAccelerator_EncodeWithFD_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class JpegEncodeAccelerator_EncodeWithFD_ResponseParamsDataView {
 public:
  JpegEncodeAccelerator_EncodeWithFD_ResponseParamsDataView() {}

  JpegEncodeAccelerator_EncodeWithFD_ResponseParamsDataView(
      internal::JpegEncodeAccelerator_EncodeWithFD_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t buffer_id() const {
    return data_->buffer_id;
  }
  uint32_t encoded_buffer_size() const {
    return data_->encoded_buffer_size;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::media::mojom::EncodeStatus>(
        data_value, output);
  }

  EncodeStatus status() const {
    return static_cast<EncodeStatus>(data_->status);
  }
 private:
  internal::JpegEncodeAccelerator_EncodeWithFD_ResponseParams_Data* data_ = nullptr;
};









}  // namespace mojom
}  // namespace media

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // MEDIA_MOJO_INTERFACES_JPEG_ENCODE_ACCELERATOR_MOJOM_PARAMS_DATA_H_