// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_MOJOM_PARAMS_DATA_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace resource_coordinator {
namespace mojom {
namespace internal {
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) FrameCoordinationUnit_GetID_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_GetID_Params_Data));
      new (data()) FrameCoordinationUnit_GetID_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_GetID_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_GetID_Params_Data>(index_);
    }
    FrameCoordinationUnit_GetID_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  FrameCoordinationUnit_GetID_Params_Data();
  ~FrameCoordinationUnit_GetID_Params_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_GetID_Params_Data) == 8,
              "Bad sizeof(FrameCoordinationUnit_GetID_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) FrameCoordinationUnit_GetID_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_GetID_ResponseParams_Data));
      new (data()) FrameCoordinationUnit_GetID_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_GetID_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_GetID_ResponseParams_Data>(index_);
    }
    FrameCoordinationUnit_GetID_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> id;

 private:
  FrameCoordinationUnit_GetID_ResponseParams_Data();
  ~FrameCoordinationUnit_GetID_ResponseParams_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_GetID_ResponseParams_Data) == 16,
              "Bad sizeof(FrameCoordinationUnit_GetID_ResponseParams_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) FrameCoordinationUnit_SetProcess_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_SetProcess_Params_Data));
      new (data()) FrameCoordinationUnit_SetProcess_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_SetProcess_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_SetProcess_Params_Data>(index_);
    }
    FrameCoordinationUnit_SetProcess_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> id;

 private:
  FrameCoordinationUnit_SetProcess_Params_Data();
  ~FrameCoordinationUnit_SetProcess_Params_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_SetProcess_Params_Data) == 16,
              "Bad sizeof(FrameCoordinationUnit_SetProcess_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) FrameCoordinationUnit_AddBinding_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_AddBinding_Params_Data));
      new (data()) FrameCoordinationUnit_AddBinding_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_AddBinding_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_AddBinding_Params_Data>(index_);
    }
    FrameCoordinationUnit_AddBinding_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  FrameCoordinationUnit_AddBinding_Params_Data();
  ~FrameCoordinationUnit_AddBinding_Params_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_AddBinding_Params_Data) == 16,
              "Bad sizeof(FrameCoordinationUnit_AddBinding_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) FrameCoordinationUnit_AddChildFrame_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_AddChildFrame_Params_Data));
      new (data()) FrameCoordinationUnit_AddChildFrame_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_AddChildFrame_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_AddChildFrame_Params_Data>(index_);
    }
    FrameCoordinationUnit_AddChildFrame_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> cu_id;

 private:
  FrameCoordinationUnit_AddChildFrame_Params_Data();
  ~FrameCoordinationUnit_AddChildFrame_Params_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_AddChildFrame_Params_Data) == 16,
              "Bad sizeof(FrameCoordinationUnit_AddChildFrame_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) FrameCoordinationUnit_RemoveChildFrame_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_RemoveChildFrame_Params_Data));
      new (data()) FrameCoordinationUnit_RemoveChildFrame_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_RemoveChildFrame_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_RemoveChildFrame_Params_Data>(index_);
    }
    FrameCoordinationUnit_RemoveChildFrame_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> cu_id;

 private:
  FrameCoordinationUnit_RemoveChildFrame_Params_Data();
  ~FrameCoordinationUnit_RemoveChildFrame_Params_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_RemoveChildFrame_Params_Data) == 16,
              "Bad sizeof(FrameCoordinationUnit_RemoveChildFrame_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data));
      new (data()) FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data>(index_);
    }
    FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t idle : 1;
  uint8_t padfinal_[7];

 private:
  FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data();
  ~FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data) == 16,
              "Bad sizeof(FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) FrameCoordinationUnit_SetLifecycleState_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_SetLifecycleState_Params_Data));
      new (data()) FrameCoordinationUnit_SetLifecycleState_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_SetLifecycleState_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_SetLifecycleState_Params_Data>(index_);
    }
    FrameCoordinationUnit_SetLifecycleState_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t state;
  uint8_t padfinal_[4];

 private:
  FrameCoordinationUnit_SetLifecycleState_Params_Data();
  ~FrameCoordinationUnit_SetLifecycleState_Params_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_SetLifecycleState_Params_Data) == 16,
              "Bad sizeof(FrameCoordinationUnit_SetLifecycleState_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) FrameCoordinationUnit_SetHasNonEmptyBeforeUnload_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_SetHasNonEmptyBeforeUnload_Params_Data));
      new (data()) FrameCoordinationUnit_SetHasNonEmptyBeforeUnload_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_SetHasNonEmptyBeforeUnload_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_SetHasNonEmptyBeforeUnload_Params_Data>(index_);
    }
    FrameCoordinationUnit_SetHasNonEmptyBeforeUnload_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t has_nonempty_beforeunload : 1;
  uint8_t padfinal_[7];

 private:
  FrameCoordinationUnit_SetHasNonEmptyBeforeUnload_Params_Data();
  ~FrameCoordinationUnit_SetHasNonEmptyBeforeUnload_Params_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_SetHasNonEmptyBeforeUnload_Params_Data) == 16,
              "Bad sizeof(FrameCoordinationUnit_SetHasNonEmptyBeforeUnload_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) FrameCoordinationUnit_SetInterventionPolicy_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_SetInterventionPolicy_Params_Data));
      new (data()) FrameCoordinationUnit_SetInterventionPolicy_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_SetInterventionPolicy_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_SetInterventionPolicy_Params_Data>(index_);
    }
    FrameCoordinationUnit_SetInterventionPolicy_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t intervention;
  int32_t policy;

 private:
  FrameCoordinationUnit_SetInterventionPolicy_Params_Data();
  ~FrameCoordinationUnit_SetInterventionPolicy_Params_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_SetInterventionPolicy_Params_Data) == 16,
              "Bad sizeof(FrameCoordinationUnit_SetInterventionPolicy_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data));
      new (data()) FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data>(index_);
    }
    FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data();
  ~FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data) == 8,
              "Bad sizeof(FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) PageCoordinationUnit_GetID_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_GetID_Params_Data));
      new (data()) PageCoordinationUnit_GetID_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_GetID_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_GetID_Params_Data>(index_);
    }
    PageCoordinationUnit_GetID_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PageCoordinationUnit_GetID_Params_Data();
  ~PageCoordinationUnit_GetID_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_GetID_Params_Data) == 8,
              "Bad sizeof(PageCoordinationUnit_GetID_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) PageCoordinationUnit_GetID_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_GetID_ResponseParams_Data));
      new (data()) PageCoordinationUnit_GetID_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_GetID_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_GetID_ResponseParams_Data>(index_);
    }
    PageCoordinationUnit_GetID_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> id;

 private:
  PageCoordinationUnit_GetID_ResponseParams_Data();
  ~PageCoordinationUnit_GetID_ResponseParams_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_GetID_ResponseParams_Data) == 16,
              "Bad sizeof(PageCoordinationUnit_GetID_ResponseParams_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) PageCoordinationUnit_AddBinding_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_AddBinding_Params_Data));
      new (data()) PageCoordinationUnit_AddBinding_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_AddBinding_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_AddBinding_Params_Data>(index_);
    }
    PageCoordinationUnit_AddBinding_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  PageCoordinationUnit_AddBinding_Params_Data();
  ~PageCoordinationUnit_AddBinding_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_AddBinding_Params_Data) == 16,
              "Bad sizeof(PageCoordinationUnit_AddBinding_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) PageCoordinationUnit_AddFrame_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_AddFrame_Params_Data));
      new (data()) PageCoordinationUnit_AddFrame_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_AddFrame_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_AddFrame_Params_Data>(index_);
    }
    PageCoordinationUnit_AddFrame_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> cu_id;

 private:
  PageCoordinationUnit_AddFrame_Params_Data();
  ~PageCoordinationUnit_AddFrame_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_AddFrame_Params_Data) == 16,
              "Bad sizeof(PageCoordinationUnit_AddFrame_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) PageCoordinationUnit_RemoveFrame_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_RemoveFrame_Params_Data));
      new (data()) PageCoordinationUnit_RemoveFrame_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_RemoveFrame_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_RemoveFrame_Params_Data>(index_);
    }
    PageCoordinationUnit_RemoveFrame_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> cu_id;

 private:
  PageCoordinationUnit_RemoveFrame_Params_Data();
  ~PageCoordinationUnit_RemoveFrame_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_RemoveFrame_Params_Data) == 16,
              "Bad sizeof(PageCoordinationUnit_RemoveFrame_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) PageCoordinationUnit_SetIsLoading_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_SetIsLoading_Params_Data));
      new (data()) PageCoordinationUnit_SetIsLoading_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_SetIsLoading_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_SetIsLoading_Params_Data>(index_);
    }
    PageCoordinationUnit_SetIsLoading_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t is_loading : 1;
  uint8_t padfinal_[7];

 private:
  PageCoordinationUnit_SetIsLoading_Params_Data();
  ~PageCoordinationUnit_SetIsLoading_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_SetIsLoading_Params_Data) == 16,
              "Bad sizeof(PageCoordinationUnit_SetIsLoading_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) PageCoordinationUnit_SetVisibility_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_SetVisibility_Params_Data));
      new (data()) PageCoordinationUnit_SetVisibility_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_SetVisibility_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_SetVisibility_Params_Data>(index_);
    }
    PageCoordinationUnit_SetVisibility_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t visible : 1;
  uint8_t padfinal_[7];

 private:
  PageCoordinationUnit_SetVisibility_Params_Data();
  ~PageCoordinationUnit_SetVisibility_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_SetVisibility_Params_Data) == 16,
              "Bad sizeof(PageCoordinationUnit_SetVisibility_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) PageCoordinationUnit_SetUKMSourceId_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_SetUKMSourceId_Params_Data));
      new (data()) PageCoordinationUnit_SetUKMSourceId_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_SetUKMSourceId_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_SetUKMSourceId_Params_Data>(index_);
    }
    PageCoordinationUnit_SetUKMSourceId_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t ukm_source_id;

 private:
  PageCoordinationUnit_SetUKMSourceId_Params_Data();
  ~PageCoordinationUnit_SetUKMSourceId_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_SetUKMSourceId_Params_Data) == 16,
              "Bad sizeof(PageCoordinationUnit_SetUKMSourceId_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) PageCoordinationUnit_OnFaviconUpdated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_OnFaviconUpdated_Params_Data));
      new (data()) PageCoordinationUnit_OnFaviconUpdated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_OnFaviconUpdated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_OnFaviconUpdated_Params_Data>(index_);
    }
    PageCoordinationUnit_OnFaviconUpdated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PageCoordinationUnit_OnFaviconUpdated_Params_Data();
  ~PageCoordinationUnit_OnFaviconUpdated_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_OnFaviconUpdated_Params_Data) == 8,
              "Bad sizeof(PageCoordinationUnit_OnFaviconUpdated_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) PageCoordinationUnit_OnTitleUpdated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_OnTitleUpdated_Params_Data));
      new (data()) PageCoordinationUnit_OnTitleUpdated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_OnTitleUpdated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_OnTitleUpdated_Params_Data>(index_);
    }
    PageCoordinationUnit_OnTitleUpdated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PageCoordinationUnit_OnTitleUpdated_Params_Data();
  ~PageCoordinationUnit_OnTitleUpdated_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_OnTitleUpdated_Params_Data) == 8,
              "Bad sizeof(PageCoordinationUnit_OnTitleUpdated_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data));
      new (data()) PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data>(index_);
    }
    PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::TimeTicks_Data> navigation_committed_time;
  int64_t navigation_id;
  mojo::internal::Pointer<mojo::internal::String_Data> url;

 private:
  PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data();
  ~PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data) == 32,
              "Bad sizeof(PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) ProcessCoordinationUnit_GetID_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_GetID_Params_Data));
      new (data()) ProcessCoordinationUnit_GetID_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_GetID_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_GetID_Params_Data>(index_);
    }
    ProcessCoordinationUnit_GetID_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ProcessCoordinationUnit_GetID_Params_Data();
  ~ProcessCoordinationUnit_GetID_Params_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_GetID_Params_Data) == 8,
              "Bad sizeof(ProcessCoordinationUnit_GetID_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) ProcessCoordinationUnit_GetID_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_GetID_ResponseParams_Data));
      new (data()) ProcessCoordinationUnit_GetID_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_GetID_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_GetID_ResponseParams_Data>(index_);
    }
    ProcessCoordinationUnit_GetID_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> id;

 private:
  ProcessCoordinationUnit_GetID_ResponseParams_Data();
  ~ProcessCoordinationUnit_GetID_ResponseParams_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_GetID_ResponseParams_Data) == 16,
              "Bad sizeof(ProcessCoordinationUnit_GetID_ResponseParams_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) ProcessCoordinationUnit_AddBinding_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_AddBinding_Params_Data));
      new (data()) ProcessCoordinationUnit_AddBinding_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_AddBinding_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_AddBinding_Params_Data>(index_);
    }
    ProcessCoordinationUnit_AddBinding_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  ProcessCoordinationUnit_AddBinding_Params_Data();
  ~ProcessCoordinationUnit_AddBinding_Params_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_AddBinding_Params_Data) == 16,
              "Bad sizeof(ProcessCoordinationUnit_AddBinding_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) ProcessCoordinationUnit_SetCPUUsage_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_SetCPUUsage_Params_Data));
      new (data()) ProcessCoordinationUnit_SetCPUUsage_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_SetCPUUsage_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_SetCPUUsage_Params_Data>(index_);
    }
    ProcessCoordinationUnit_SetCPUUsage_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  double cpu_usage;

 private:
  ProcessCoordinationUnit_SetCPUUsage_Params_Data();
  ~ProcessCoordinationUnit_SetCPUUsage_Params_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_SetCPUUsage_Params_Data) == 16,
              "Bad sizeof(ProcessCoordinationUnit_SetCPUUsage_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data));
      new (data()) ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data>(index_);
    }
    ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::TimeDelta_Data> duration;

 private:
  ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data();
  ~ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data) == 16,
              "Bad sizeof(ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) ProcessCoordinationUnit_SetLaunchTime_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_SetLaunchTime_Params_Data));
      new (data()) ProcessCoordinationUnit_SetLaunchTime_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_SetLaunchTime_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_SetLaunchTime_Params_Data>(index_);
    }
    ProcessCoordinationUnit_SetLaunchTime_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::Time_Data> launch_time;

 private:
  ProcessCoordinationUnit_SetLaunchTime_Params_Data();
  ~ProcessCoordinationUnit_SetLaunchTime_Params_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_SetLaunchTime_Params_Data) == 16,
              "Bad sizeof(ProcessCoordinationUnit_SetLaunchTime_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data));
      new (data()) ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data>(index_);
    }
    ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t main_thread_task_load_is_low : 1;
  uint8_t padfinal_[7];

 private:
  ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data();
  ~ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data) == 16,
              "Bad sizeof(ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) ProcessCoordinationUnit_SetPID_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_SetPID_Params_Data));
      new (data()) ProcessCoordinationUnit_SetPID_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_SetPID_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_SetPID_Params_Data>(index_);
    }
    ProcessCoordinationUnit_SetPID_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::ProcessId_Data> pid;

 private:
  ProcessCoordinationUnit_SetPID_Params_Data();
  ~ProcessCoordinationUnit_SetPID_Params_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_SetPID_Params_Data) == 16,
              "Bad sizeof(ProcessCoordinationUnit_SetPID_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) ProcessCoordinationUnit_SetProcessExitStatus_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_SetProcessExitStatus_Params_Data));
      new (data()) ProcessCoordinationUnit_SetProcessExitStatus_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_SetProcessExitStatus_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_SetProcessExitStatus_Params_Data>(index_);
    }
    ProcessCoordinationUnit_SetProcessExitStatus_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t exit_status;
  uint8_t padfinal_[4];

 private:
  ProcessCoordinationUnit_SetProcessExitStatus_Params_Data();
  ~ProcessCoordinationUnit_SetProcessExitStatus_Params_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_SetProcessExitStatus_Params_Data) == 16,
              "Bad sizeof(ProcessCoordinationUnit_SetProcessExitStatus_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) ProcessCoordinationUnit_OnRendererIsBloated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_OnRendererIsBloated_Params_Data));
      new (data()) ProcessCoordinationUnit_OnRendererIsBloated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_OnRendererIsBloated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_OnRendererIsBloated_Params_Data>(index_);
    }
    ProcessCoordinationUnit_OnRendererIsBloated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ProcessCoordinationUnit_OnRendererIsBloated_Params_Data();
  ~ProcessCoordinationUnit_OnRendererIsBloated_Params_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_OnRendererIsBloated_Params_Data) == 8,
              "Bad sizeof(ProcessCoordinationUnit_OnRendererIsBloated_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) SystemCoordinationUnit_GetID_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SystemCoordinationUnit_GetID_Params_Data));
      new (data()) SystemCoordinationUnit_GetID_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SystemCoordinationUnit_GetID_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SystemCoordinationUnit_GetID_Params_Data>(index_);
    }
    SystemCoordinationUnit_GetID_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  SystemCoordinationUnit_GetID_Params_Data();
  ~SystemCoordinationUnit_GetID_Params_Data() = delete;
};
static_assert(sizeof(SystemCoordinationUnit_GetID_Params_Data) == 8,
              "Bad sizeof(SystemCoordinationUnit_GetID_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) SystemCoordinationUnit_GetID_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SystemCoordinationUnit_GetID_ResponseParams_Data));
      new (data()) SystemCoordinationUnit_GetID_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SystemCoordinationUnit_GetID_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SystemCoordinationUnit_GetID_ResponseParams_Data>(index_);
    }
    SystemCoordinationUnit_GetID_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> id;

 private:
  SystemCoordinationUnit_GetID_ResponseParams_Data();
  ~SystemCoordinationUnit_GetID_ResponseParams_Data() = delete;
};
static_assert(sizeof(SystemCoordinationUnit_GetID_ResponseParams_Data) == 16,
              "Bad sizeof(SystemCoordinationUnit_GetID_ResponseParams_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) SystemCoordinationUnit_AddBinding_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SystemCoordinationUnit_AddBinding_Params_Data));
      new (data()) SystemCoordinationUnit_AddBinding_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SystemCoordinationUnit_AddBinding_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SystemCoordinationUnit_AddBinding_Params_Data>(index_);
    }
    SystemCoordinationUnit_AddBinding_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  SystemCoordinationUnit_AddBinding_Params_Data();
  ~SystemCoordinationUnit_AddBinding_Params_Data() = delete;
};
static_assert(sizeof(SystemCoordinationUnit_AddBinding_Params_Data) == 16,
              "Bad sizeof(SystemCoordinationUnit_AddBinding_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) SystemCoordinationUnit_OnProcessCPUUsageReady_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SystemCoordinationUnit_OnProcessCPUUsageReady_Params_Data));
      new (data()) SystemCoordinationUnit_OnProcessCPUUsageReady_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SystemCoordinationUnit_OnProcessCPUUsageReady_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SystemCoordinationUnit_OnProcessCPUUsageReady_Params_Data>(index_);
    }
    SystemCoordinationUnit_OnProcessCPUUsageReady_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  SystemCoordinationUnit_OnProcessCPUUsageReady_Params_Data();
  ~SystemCoordinationUnit_OnProcessCPUUsageReady_Params_Data() = delete;
};
static_assert(sizeof(SystemCoordinationUnit_OnProcessCPUUsageReady_Params_Data) == 8,
              "Bad sizeof(SystemCoordinationUnit_OnProcessCPUUsageReady_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) SystemCoordinationUnit_DistributeMeasurementBatch_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SystemCoordinationUnit_DistributeMeasurementBatch_Params_Data));
      new (data()) SystemCoordinationUnit_DistributeMeasurementBatch_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SystemCoordinationUnit_DistributeMeasurementBatch_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SystemCoordinationUnit_DistributeMeasurementBatch_Params_Data>(index_);
    }
    SystemCoordinationUnit_DistributeMeasurementBatch_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::ProcessResourceMeasurementBatch_Data> measurement_batch;

 private:
  SystemCoordinationUnit_DistributeMeasurementBatch_Params_Data();
  ~SystemCoordinationUnit_DistributeMeasurementBatch_Params_Data() = delete;
};
static_assert(sizeof(SystemCoordinationUnit_DistributeMeasurementBatch_Params_Data) == 16,
              "Bad sizeof(SystemCoordinationUnit_DistributeMeasurementBatch_Params_Data)");

}  // namespace internal
class FrameCoordinationUnit_GetID_ParamsDataView {
 public:
  FrameCoordinationUnit_GetID_ParamsDataView() {}

  FrameCoordinationUnit_GetID_ParamsDataView(
      internal::FrameCoordinationUnit_GetID_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::FrameCoordinationUnit_GetID_Params_Data* data_ = nullptr;
};

class FrameCoordinationUnit_GetID_ResponseParamsDataView {
 public:
  FrameCoordinationUnit_GetID_ResponseParamsDataView() {}

  FrameCoordinationUnit_GetID_ResponseParamsDataView(
      internal::FrameCoordinationUnit_GetID_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetIdDataView(
      CoordinationUnitIDDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadId(UserType* output) {
    auto* pointer = data_->id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
        pointer, output, context_);
  }
 private:
  internal::FrameCoordinationUnit_GetID_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class FrameCoordinationUnit_SetProcess_ParamsDataView {
 public:
  FrameCoordinationUnit_SetProcess_ParamsDataView() {}

  FrameCoordinationUnit_SetProcess_ParamsDataView(
      internal::FrameCoordinationUnit_SetProcess_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetIdDataView(
      CoordinationUnitIDDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadId(UserType* output) {
    auto* pointer = data_->id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
        pointer, output, context_);
  }
 private:
  internal::FrameCoordinationUnit_SetProcess_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class FrameCoordinationUnit_AddBinding_ParamsDataView {
 public:
  FrameCoordinationUnit_AddBinding_ParamsDataView() {}

  FrameCoordinationUnit_AddBinding_ParamsDataView(
      internal::FrameCoordinationUnit_AddBinding_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeRequest() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::resource_coordinator::mojom::FrameCoordinationUnitRequestDataView>(
            &data_->request, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::FrameCoordinationUnit_AddBinding_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class FrameCoordinationUnit_AddChildFrame_ParamsDataView {
 public:
  FrameCoordinationUnit_AddChildFrame_ParamsDataView() {}

  FrameCoordinationUnit_AddChildFrame_ParamsDataView(
      internal::FrameCoordinationUnit_AddChildFrame_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetCuIdDataView(
      CoordinationUnitIDDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCuId(UserType* output) {
    auto* pointer = data_->cu_id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
        pointer, output, context_);
  }
 private:
  internal::FrameCoordinationUnit_AddChildFrame_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class FrameCoordinationUnit_RemoveChildFrame_ParamsDataView {
 public:
  FrameCoordinationUnit_RemoveChildFrame_ParamsDataView() {}

  FrameCoordinationUnit_RemoveChildFrame_ParamsDataView(
      internal::FrameCoordinationUnit_RemoveChildFrame_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetCuIdDataView(
      CoordinationUnitIDDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCuId(UserType* output) {
    auto* pointer = data_->cu_id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
        pointer, output, context_);
  }
 private:
  internal::FrameCoordinationUnit_RemoveChildFrame_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class FrameCoordinationUnit_SetNetworkAlmostIdle_ParamsDataView {
 public:
  FrameCoordinationUnit_SetNetworkAlmostIdle_ParamsDataView() {}

  FrameCoordinationUnit_SetNetworkAlmostIdle_ParamsDataView(
      internal::FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool idle() const {
    return data_->idle;
  }
 private:
  internal::FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data* data_ = nullptr;
};

class FrameCoordinationUnit_SetLifecycleState_ParamsDataView {
 public:
  FrameCoordinationUnit_SetLifecycleState_ParamsDataView() {}

  FrameCoordinationUnit_SetLifecycleState_ParamsDataView(
      internal::FrameCoordinationUnit_SetLifecycleState_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadState(UserType* output) const {
    auto data_value = data_->state;
    return mojo::internal::Deserialize<::resource_coordinator::mojom::LifecycleState>(
        data_value, output);
  }

  ::resource_coordinator::mojom::LifecycleState state() const {
    return static_cast<::resource_coordinator::mojom::LifecycleState>(data_->state);
  }
 private:
  internal::FrameCoordinationUnit_SetLifecycleState_Params_Data* data_ = nullptr;
};

class FrameCoordinationUnit_SetHasNonEmptyBeforeUnload_ParamsDataView {
 public:
  FrameCoordinationUnit_SetHasNonEmptyBeforeUnload_ParamsDataView() {}

  FrameCoordinationUnit_SetHasNonEmptyBeforeUnload_ParamsDataView(
      internal::FrameCoordinationUnit_SetHasNonEmptyBeforeUnload_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool has_nonempty_beforeunload() const {
    return data_->has_nonempty_beforeunload;
  }
 private:
  internal::FrameCoordinationUnit_SetHasNonEmptyBeforeUnload_Params_Data* data_ = nullptr;
};

class FrameCoordinationUnit_SetInterventionPolicy_ParamsDataView {
 public:
  FrameCoordinationUnit_SetInterventionPolicy_ParamsDataView() {}

  FrameCoordinationUnit_SetInterventionPolicy_ParamsDataView(
      internal::FrameCoordinationUnit_SetInterventionPolicy_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadIntervention(UserType* output) const {
    auto data_value = data_->intervention;
    return mojo::internal::Deserialize<::resource_coordinator::mojom::PolicyControlledIntervention>(
        data_value, output);
  }

  PolicyControlledIntervention intervention() const {
    return static_cast<PolicyControlledIntervention>(data_->intervention);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPolicy(UserType* output) const {
    auto data_value = data_->policy;
    return mojo::internal::Deserialize<::resource_coordinator::mojom::InterventionPolicy>(
        data_value, output);
  }

  InterventionPolicy policy() const {
    return static_cast<InterventionPolicy>(data_->policy);
  }
 private:
  internal::FrameCoordinationUnit_SetInterventionPolicy_Params_Data* data_ = nullptr;
};

class FrameCoordinationUnit_OnNonPersistentNotificationCreated_ParamsDataView {
 public:
  FrameCoordinationUnit_OnNonPersistentNotificationCreated_ParamsDataView() {}

  FrameCoordinationUnit_OnNonPersistentNotificationCreated_ParamsDataView(
      internal::FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data* data_ = nullptr;
};

class PageCoordinationUnit_GetID_ParamsDataView {
 public:
  PageCoordinationUnit_GetID_ParamsDataView() {}

  PageCoordinationUnit_GetID_ParamsDataView(
      internal::PageCoordinationUnit_GetID_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PageCoordinationUnit_GetID_Params_Data* data_ = nullptr;
};

class PageCoordinationUnit_GetID_ResponseParamsDataView {
 public:
  PageCoordinationUnit_GetID_ResponseParamsDataView() {}

  PageCoordinationUnit_GetID_ResponseParamsDataView(
      internal::PageCoordinationUnit_GetID_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetIdDataView(
      CoordinationUnitIDDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadId(UserType* output) {
    auto* pointer = data_->id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
        pointer, output, context_);
  }
 private:
  internal::PageCoordinationUnit_GetID_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageCoordinationUnit_AddBinding_ParamsDataView {
 public:
  PageCoordinationUnit_AddBinding_ParamsDataView() {}

  PageCoordinationUnit_AddBinding_ParamsDataView(
      internal::PageCoordinationUnit_AddBinding_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeRequest() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::resource_coordinator::mojom::PageCoordinationUnitRequestDataView>(
            &data_->request, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::PageCoordinationUnit_AddBinding_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageCoordinationUnit_AddFrame_ParamsDataView {
 public:
  PageCoordinationUnit_AddFrame_ParamsDataView() {}

  PageCoordinationUnit_AddFrame_ParamsDataView(
      internal::PageCoordinationUnit_AddFrame_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetCuIdDataView(
      CoordinationUnitIDDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCuId(UserType* output) {
    auto* pointer = data_->cu_id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
        pointer, output, context_);
  }
 private:
  internal::PageCoordinationUnit_AddFrame_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageCoordinationUnit_RemoveFrame_ParamsDataView {
 public:
  PageCoordinationUnit_RemoveFrame_ParamsDataView() {}

  PageCoordinationUnit_RemoveFrame_ParamsDataView(
      internal::PageCoordinationUnit_RemoveFrame_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetCuIdDataView(
      CoordinationUnitIDDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCuId(UserType* output) {
    auto* pointer = data_->cu_id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
        pointer, output, context_);
  }
 private:
  internal::PageCoordinationUnit_RemoveFrame_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageCoordinationUnit_SetIsLoading_ParamsDataView {
 public:
  PageCoordinationUnit_SetIsLoading_ParamsDataView() {}

  PageCoordinationUnit_SetIsLoading_ParamsDataView(
      internal::PageCoordinationUnit_SetIsLoading_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool is_loading() const {
    return data_->is_loading;
  }
 private:
  internal::PageCoordinationUnit_SetIsLoading_Params_Data* data_ = nullptr;
};

class PageCoordinationUnit_SetVisibility_ParamsDataView {
 public:
  PageCoordinationUnit_SetVisibility_ParamsDataView() {}

  PageCoordinationUnit_SetVisibility_ParamsDataView(
      internal::PageCoordinationUnit_SetVisibility_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool visible() const {
    return data_->visible;
  }
 private:
  internal::PageCoordinationUnit_SetVisibility_Params_Data* data_ = nullptr;
};

class PageCoordinationUnit_SetUKMSourceId_ParamsDataView {
 public:
  PageCoordinationUnit_SetUKMSourceId_ParamsDataView() {}

  PageCoordinationUnit_SetUKMSourceId_ParamsDataView(
      internal::PageCoordinationUnit_SetUKMSourceId_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t ukm_source_id() const {
    return data_->ukm_source_id;
  }
 private:
  internal::PageCoordinationUnit_SetUKMSourceId_Params_Data* data_ = nullptr;
};

class PageCoordinationUnit_OnFaviconUpdated_ParamsDataView {
 public:
  PageCoordinationUnit_OnFaviconUpdated_ParamsDataView() {}

  PageCoordinationUnit_OnFaviconUpdated_ParamsDataView(
      internal::PageCoordinationUnit_OnFaviconUpdated_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PageCoordinationUnit_OnFaviconUpdated_Params_Data* data_ = nullptr;
};

class PageCoordinationUnit_OnTitleUpdated_ParamsDataView {
 public:
  PageCoordinationUnit_OnTitleUpdated_ParamsDataView() {}

  PageCoordinationUnit_OnTitleUpdated_ParamsDataView(
      internal::PageCoordinationUnit_OnTitleUpdated_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PageCoordinationUnit_OnTitleUpdated_Params_Data* data_ = nullptr;
};

class PageCoordinationUnit_OnMainFrameNavigationCommitted_ParamsDataView {
 public:
  PageCoordinationUnit_OnMainFrameNavigationCommitted_ParamsDataView() {}

  PageCoordinationUnit_OnMainFrameNavigationCommitted_ParamsDataView(
      internal::PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetNavigationCommittedTimeDataView(
      ::mojo_base::mojom::TimeTicksDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadNavigationCommittedTime(UserType* output) {
    auto* pointer = data_->navigation_committed_time.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeTicksDataView>(
        pointer, output, context_);
  }
  int64_t navigation_id() const {
    return data_->navigation_id;
  }
  inline void GetUrlDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ProcessCoordinationUnit_GetID_ParamsDataView {
 public:
  ProcessCoordinationUnit_GetID_ParamsDataView() {}

  ProcessCoordinationUnit_GetID_ParamsDataView(
      internal::ProcessCoordinationUnit_GetID_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ProcessCoordinationUnit_GetID_Params_Data* data_ = nullptr;
};

class ProcessCoordinationUnit_GetID_ResponseParamsDataView {
 public:
  ProcessCoordinationUnit_GetID_ResponseParamsDataView() {}

  ProcessCoordinationUnit_GetID_ResponseParamsDataView(
      internal::ProcessCoordinationUnit_GetID_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetIdDataView(
      CoordinationUnitIDDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadId(UserType* output) {
    auto* pointer = data_->id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
        pointer, output, context_);
  }
 private:
  internal::ProcessCoordinationUnit_GetID_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ProcessCoordinationUnit_AddBinding_ParamsDataView {
 public:
  ProcessCoordinationUnit_AddBinding_ParamsDataView() {}

  ProcessCoordinationUnit_AddBinding_ParamsDataView(
      internal::ProcessCoordinationUnit_AddBinding_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeRequest() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::resource_coordinator::mojom::ProcessCoordinationUnitRequestDataView>(
            &data_->request, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::ProcessCoordinationUnit_AddBinding_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ProcessCoordinationUnit_SetCPUUsage_ParamsDataView {
 public:
  ProcessCoordinationUnit_SetCPUUsage_ParamsDataView() {}

  ProcessCoordinationUnit_SetCPUUsage_ParamsDataView(
      internal::ProcessCoordinationUnit_SetCPUUsage_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  double cpu_usage() const {
    return data_->cpu_usage;
  }
 private:
  internal::ProcessCoordinationUnit_SetCPUUsage_Params_Data* data_ = nullptr;
};

class ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_ParamsDataView {
 public:
  ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_ParamsDataView() {}

  ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_ParamsDataView(
      internal::ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDurationDataView(
      ::mojo_base::mojom::TimeDeltaDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDuration(UserType* output) {
    auto* pointer = data_->duration.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDeltaDataView>(
        pointer, output, context_);
  }
 private:
  internal::ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ProcessCoordinationUnit_SetLaunchTime_ParamsDataView {
 public:
  ProcessCoordinationUnit_SetLaunchTime_ParamsDataView() {}

  ProcessCoordinationUnit_SetLaunchTime_ParamsDataView(
      internal::ProcessCoordinationUnit_SetLaunchTime_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetLaunchTimeDataView(
      ::mojo_base::mojom::TimeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadLaunchTime(UserType* output) {
    auto* pointer = data_->launch_time.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDataView>(
        pointer, output, context_);
  }
 private:
  internal::ProcessCoordinationUnit_SetLaunchTime_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_ParamsDataView {
 public:
  ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_ParamsDataView() {}

  ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_ParamsDataView(
      internal::ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool main_thread_task_load_is_low() const {
    return data_->main_thread_task_load_is_low;
  }
 private:
  internal::ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data* data_ = nullptr;
};

class ProcessCoordinationUnit_SetPID_ParamsDataView {
 public:
  ProcessCoordinationUnit_SetPID_ParamsDataView() {}

  ProcessCoordinationUnit_SetPID_ParamsDataView(
      internal::ProcessCoordinationUnit_SetPID_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPidDataView(
      ::mojo_base::mojom::ProcessIdDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPid(UserType* output) {
    auto* pointer = data_->pid.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::ProcessIdDataView>(
        pointer, output, context_);
  }
 private:
  internal::ProcessCoordinationUnit_SetPID_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ProcessCoordinationUnit_SetProcessExitStatus_ParamsDataView {
 public:
  ProcessCoordinationUnit_SetProcessExitStatus_ParamsDataView() {}

  ProcessCoordinationUnit_SetProcessExitStatus_ParamsDataView(
      internal::ProcessCoordinationUnit_SetProcessExitStatus_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t exit_status() const {
    return data_->exit_status;
  }
 private:
  internal::ProcessCoordinationUnit_SetProcessExitStatus_Params_Data* data_ = nullptr;
};

class ProcessCoordinationUnit_OnRendererIsBloated_ParamsDataView {
 public:
  ProcessCoordinationUnit_OnRendererIsBloated_ParamsDataView() {}

  ProcessCoordinationUnit_OnRendererIsBloated_ParamsDataView(
      internal::ProcessCoordinationUnit_OnRendererIsBloated_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ProcessCoordinationUnit_OnRendererIsBloated_Params_Data* data_ = nullptr;
};

class SystemCoordinationUnit_GetID_ParamsDataView {
 public:
  SystemCoordinationUnit_GetID_ParamsDataView() {}

  SystemCoordinationUnit_GetID_ParamsDataView(
      internal::SystemCoordinationUnit_GetID_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::SystemCoordinationUnit_GetID_Params_Data* data_ = nullptr;
};

class SystemCoordinationUnit_GetID_ResponseParamsDataView {
 public:
  SystemCoordinationUnit_GetID_ResponseParamsDataView() {}

  SystemCoordinationUnit_GetID_ResponseParamsDataView(
      internal::SystemCoordinationUnit_GetID_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetIdDataView(
      CoordinationUnitIDDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadId(UserType* output) {
    auto* pointer = data_->id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
        pointer, output, context_);
  }
 private:
  internal::SystemCoordinationUnit_GetID_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class SystemCoordinationUnit_AddBinding_ParamsDataView {
 public:
  SystemCoordinationUnit_AddBinding_ParamsDataView() {}

  SystemCoordinationUnit_AddBinding_ParamsDataView(
      internal::SystemCoordinationUnit_AddBinding_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeRequest() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::resource_coordinator::mojom::SystemCoordinationUnitRequestDataView>(
            &data_->request, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::SystemCoordinationUnit_AddBinding_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class SystemCoordinationUnit_OnProcessCPUUsageReady_ParamsDataView {
 public:
  SystemCoordinationUnit_OnProcessCPUUsageReady_ParamsDataView() {}

  SystemCoordinationUnit_OnProcessCPUUsageReady_ParamsDataView(
      internal::SystemCoordinationUnit_OnProcessCPUUsageReady_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::SystemCoordinationUnit_OnProcessCPUUsageReady_Params_Data* data_ = nullptr;
};

class SystemCoordinationUnit_DistributeMeasurementBatch_ParamsDataView {
 public:
  SystemCoordinationUnit_DistributeMeasurementBatch_ParamsDataView() {}

  SystemCoordinationUnit_DistributeMeasurementBatch_ParamsDataView(
      internal::SystemCoordinationUnit_DistributeMeasurementBatch_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetMeasurementBatchDataView(
      ProcessResourceMeasurementBatchDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMeasurementBatch(UserType* output) {
    auto* pointer = data_->measurement_batch.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::ProcessResourceMeasurementBatchDataView>(
        pointer, output, context_);
  }
 private:
  internal::SystemCoordinationUnit_DistributeMeasurementBatch_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};




inline void FrameCoordinationUnit_GetID_ResponseParamsDataView::GetIdDataView(
    CoordinationUnitIDDataView* output) {
  auto pointer = data_->id.Get();
  *output = CoordinationUnitIDDataView(pointer, context_);
}


inline void FrameCoordinationUnit_SetProcess_ParamsDataView::GetIdDataView(
    CoordinationUnitIDDataView* output) {
  auto pointer = data_->id.Get();
  *output = CoordinationUnitIDDataView(pointer, context_);
}




inline void FrameCoordinationUnit_AddChildFrame_ParamsDataView::GetCuIdDataView(
    CoordinationUnitIDDataView* output) {
  auto pointer = data_->cu_id.Get();
  *output = CoordinationUnitIDDataView(pointer, context_);
}


inline void FrameCoordinationUnit_RemoveChildFrame_ParamsDataView::GetCuIdDataView(
    CoordinationUnitIDDataView* output) {
  auto pointer = data_->cu_id.Get();
  *output = CoordinationUnitIDDataView(pointer, context_);
}














inline void PageCoordinationUnit_GetID_ResponseParamsDataView::GetIdDataView(
    CoordinationUnitIDDataView* output) {
  auto pointer = data_->id.Get();
  *output = CoordinationUnitIDDataView(pointer, context_);
}




inline void PageCoordinationUnit_AddFrame_ParamsDataView::GetCuIdDataView(
    CoordinationUnitIDDataView* output) {
  auto pointer = data_->cu_id.Get();
  *output = CoordinationUnitIDDataView(pointer, context_);
}


inline void PageCoordinationUnit_RemoveFrame_ParamsDataView::GetCuIdDataView(
    CoordinationUnitIDDataView* output) {
  auto pointer = data_->cu_id.Get();
  *output = CoordinationUnitIDDataView(pointer, context_);
}












inline void PageCoordinationUnit_OnMainFrameNavigationCommitted_ParamsDataView::GetNavigationCommittedTimeDataView(
    ::mojo_base::mojom::TimeTicksDataView* output) {
  auto pointer = data_->navigation_committed_time.Get();
  *output = ::mojo_base::mojom::TimeTicksDataView(pointer, context_);
}
inline void PageCoordinationUnit_OnMainFrameNavigationCommitted_ParamsDataView::GetUrlDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->url.Get();
  *output = mojo::StringDataView(pointer, context_);
}




inline void ProcessCoordinationUnit_GetID_ResponseParamsDataView::GetIdDataView(
    CoordinationUnitIDDataView* output) {
  auto pointer = data_->id.Get();
  *output = CoordinationUnitIDDataView(pointer, context_);
}






inline void ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_ParamsDataView::GetDurationDataView(
    ::mojo_base::mojom::TimeDeltaDataView* output) {
  auto pointer = data_->duration.Get();
  *output = ::mojo_base::mojom::TimeDeltaDataView(pointer, context_);
}


inline void ProcessCoordinationUnit_SetLaunchTime_ParamsDataView::GetLaunchTimeDataView(
    ::mojo_base::mojom::TimeDataView* output) {
  auto pointer = data_->launch_time.Get();
  *output = ::mojo_base::mojom::TimeDataView(pointer, context_);
}




inline void ProcessCoordinationUnit_SetPID_ParamsDataView::GetPidDataView(
    ::mojo_base::mojom::ProcessIdDataView* output) {
  auto pointer = data_->pid.Get();
  *output = ::mojo_base::mojom::ProcessIdDataView(pointer, context_);
}








inline void SystemCoordinationUnit_GetID_ResponseParamsDataView::GetIdDataView(
    CoordinationUnitIDDataView* output) {
  auto pointer = data_->id.Get();
  *output = CoordinationUnitIDDataView(pointer, context_);
}






inline void SystemCoordinationUnit_DistributeMeasurementBatch_ParamsDataView::GetMeasurementBatchDataView(
    ProcessResourceMeasurementBatchDataView* output) {
  auto pointer = data_->measurement_batch.Get();
  *output = ProcessResourceMeasurementBatchDataView(pointer, context_);
}

}  // namespace mojom
}  // namespace resource_coordinator

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_MOJOM_PARAMS_DATA_H_