// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_INTROSPECTOR_MOJOM_PARAMS_DATA_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_INTROSPECTOR_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace resource_coordinator {
namespace mojom {
namespace internal {
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) CoordinationUnitIntrospector_GetProcessToURLMap_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CoordinationUnitIntrospector_GetProcessToURLMap_Params_Data));
      new (data()) CoordinationUnitIntrospector_GetProcessToURLMap_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CoordinationUnitIntrospector_GetProcessToURLMap_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CoordinationUnitIntrospector_GetProcessToURLMap_Params_Data>(index_);
    }
    CoordinationUnitIntrospector_GetProcessToURLMap_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  CoordinationUnitIntrospector_GetProcessToURLMap_Params_Data();
  ~CoordinationUnitIntrospector_GetProcessToURLMap_Params_Data() = delete;
};
static_assert(sizeof(CoordinationUnitIntrospector_GetProcessToURLMap_Params_Data) == 8,
              "Bad sizeof(CoordinationUnitIntrospector_GetProcessToURLMap_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) CoordinationUnitIntrospector_GetProcessToURLMap_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CoordinationUnitIntrospector_GetProcessToURLMap_ResponseParams_Data));
      new (data()) CoordinationUnitIntrospector_GetProcessToURLMap_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CoordinationUnitIntrospector_GetProcessToURLMap_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CoordinationUnitIntrospector_GetProcessToURLMap_ResponseParams_Data>(index_);
    }
    CoordinationUnitIntrospector_GetProcessToURLMap_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::ProcessInfo_Data>>> process_infos;

 private:
  CoordinationUnitIntrospector_GetProcessToURLMap_ResponseParams_Data();
  ~CoordinationUnitIntrospector_GetProcessToURLMap_ResponseParams_Data() = delete;
};
static_assert(sizeof(CoordinationUnitIntrospector_GetProcessToURLMap_ResponseParams_Data) == 16,
              "Bad sizeof(CoordinationUnitIntrospector_GetProcessToURLMap_ResponseParams_Data)");

}  // namespace internal
class CoordinationUnitIntrospector_GetProcessToURLMap_ParamsDataView {
 public:
  CoordinationUnitIntrospector_GetProcessToURLMap_ParamsDataView() {}

  CoordinationUnitIntrospector_GetProcessToURLMap_ParamsDataView(
      internal::CoordinationUnitIntrospector_GetProcessToURLMap_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::CoordinationUnitIntrospector_GetProcessToURLMap_Params_Data* data_ = nullptr;
};

class CoordinationUnitIntrospector_GetProcessToURLMap_ResponseParamsDataView {
 public:
  CoordinationUnitIntrospector_GetProcessToURLMap_ResponseParamsDataView() {}

  CoordinationUnitIntrospector_GetProcessToURLMap_ResponseParamsDataView(
      internal::CoordinationUnitIntrospector_GetProcessToURLMap_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetProcessInfosDataView(
      mojo::ArrayDataView<ProcessInfoDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadProcessInfos(UserType* output) {
    auto* pointer = data_->process_infos.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::resource_coordinator::mojom::ProcessInfoDataView>>(
        pointer, output, context_);
  }
 private:
  internal::CoordinationUnitIntrospector_GetProcessToURLMap_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};




inline void CoordinationUnitIntrospector_GetProcessToURLMap_ResponseParamsDataView::GetProcessInfosDataView(
    mojo::ArrayDataView<ProcessInfoDataView>* output) {
  auto pointer = data_->process_infos.Get();
  *output = mojo::ArrayDataView<ProcessInfoDataView>(pointer, context_);
}

}  // namespace mojom
}  // namespace resource_coordinator

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_INTROSPECTOR_MOJOM_PARAMS_DATA_H_