// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_PROVIDER_MOJOM_PARAMS_DATA_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_PROVIDER_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace resource_coordinator {
namespace mojom {
namespace internal {
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) CoordinationUnitProvider_CreateFrameCoordinationUnit_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CoordinationUnitProvider_CreateFrameCoordinationUnit_Params_Data));
      new (data()) CoordinationUnitProvider_CreateFrameCoordinationUnit_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CoordinationUnitProvider_CreateFrameCoordinationUnit_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CoordinationUnitProvider_CreateFrameCoordinationUnit_Params_Data>(index_);
    }
    CoordinationUnitProvider_CreateFrameCoordinationUnit_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::resource_coordinator::mojom::internal::CoordinationUnitID_Data> id;

 private:
  CoordinationUnitProvider_CreateFrameCoordinationUnit_Params_Data();
  ~CoordinationUnitProvider_CreateFrameCoordinationUnit_Params_Data() = delete;
};
static_assert(sizeof(CoordinationUnitProvider_CreateFrameCoordinationUnit_Params_Data) == 24,
              "Bad sizeof(CoordinationUnitProvider_CreateFrameCoordinationUnit_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) CoordinationUnitProvider_CreatePageCoordinationUnit_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CoordinationUnitProvider_CreatePageCoordinationUnit_Params_Data));
      new (data()) CoordinationUnitProvider_CreatePageCoordinationUnit_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CoordinationUnitProvider_CreatePageCoordinationUnit_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CoordinationUnitProvider_CreatePageCoordinationUnit_Params_Data>(index_);
    }
    CoordinationUnitProvider_CreatePageCoordinationUnit_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::resource_coordinator::mojom::internal::CoordinationUnitID_Data> id;

 private:
  CoordinationUnitProvider_CreatePageCoordinationUnit_Params_Data();
  ~CoordinationUnitProvider_CreatePageCoordinationUnit_Params_Data() = delete;
};
static_assert(sizeof(CoordinationUnitProvider_CreatePageCoordinationUnit_Params_Data) == 24,
              "Bad sizeof(CoordinationUnitProvider_CreatePageCoordinationUnit_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) CoordinationUnitProvider_CreateProcessCoordinationUnit_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CoordinationUnitProvider_CreateProcessCoordinationUnit_Params_Data));
      new (data()) CoordinationUnitProvider_CreateProcessCoordinationUnit_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CoordinationUnitProvider_CreateProcessCoordinationUnit_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CoordinationUnitProvider_CreateProcessCoordinationUnit_Params_Data>(index_);
    }
    CoordinationUnitProvider_CreateProcessCoordinationUnit_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::resource_coordinator::mojom::internal::CoordinationUnitID_Data> id;

 private:
  CoordinationUnitProvider_CreateProcessCoordinationUnit_Params_Data();
  ~CoordinationUnitProvider_CreateProcessCoordinationUnit_Params_Data() = delete;
};
static_assert(sizeof(CoordinationUnitProvider_CreateProcessCoordinationUnit_Params_Data) == 24,
              "Bad sizeof(CoordinationUnitProvider_CreateProcessCoordinationUnit_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) CoordinationUnitProvider_GetSystemCoordinationUnit_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CoordinationUnitProvider_GetSystemCoordinationUnit_Params_Data));
      new (data()) CoordinationUnitProvider_GetSystemCoordinationUnit_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CoordinationUnitProvider_GetSystemCoordinationUnit_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CoordinationUnitProvider_GetSystemCoordinationUnit_Params_Data>(index_);
    }
    CoordinationUnitProvider_GetSystemCoordinationUnit_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  CoordinationUnitProvider_GetSystemCoordinationUnit_Params_Data();
  ~CoordinationUnitProvider_GetSystemCoordinationUnit_Params_Data() = delete;
};
static_assert(sizeof(CoordinationUnitProvider_GetSystemCoordinationUnit_Params_Data) == 16,
              "Bad sizeof(CoordinationUnitProvider_GetSystemCoordinationUnit_Params_Data)");

}  // namespace internal
class CoordinationUnitProvider_CreateFrameCoordinationUnit_ParamsDataView {
 public:
  CoordinationUnitProvider_CreateFrameCoordinationUnit_ParamsDataView() {}

  CoordinationUnitProvider_CreateFrameCoordinationUnit_ParamsDataView(
      internal::CoordinationUnitProvider_CreateFrameCoordinationUnit_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeRequest() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::resource_coordinator::mojom::FrameCoordinationUnitRequestDataView>(
            &data_->request, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetIdDataView(
      ::resource_coordinator::mojom::CoordinationUnitIDDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadId(UserType* output) {
    auto* pointer = data_->id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
        pointer, output, context_);
  }
 private:
  internal::CoordinationUnitProvider_CreateFrameCoordinationUnit_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class CoordinationUnitProvider_CreatePageCoordinationUnit_ParamsDataView {
 public:
  CoordinationUnitProvider_CreatePageCoordinationUnit_ParamsDataView() {}

  CoordinationUnitProvider_CreatePageCoordinationUnit_ParamsDataView(
      internal::CoordinationUnitProvider_CreatePageCoordinationUnit_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeRequest() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::resource_coordinator::mojom::PageCoordinationUnitRequestDataView>(
            &data_->request, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetIdDataView(
      ::resource_coordinator::mojom::CoordinationUnitIDDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadId(UserType* output) {
    auto* pointer = data_->id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
        pointer, output, context_);
  }
 private:
  internal::CoordinationUnitProvider_CreatePageCoordinationUnit_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class CoordinationUnitProvider_CreateProcessCoordinationUnit_ParamsDataView {
 public:
  CoordinationUnitProvider_CreateProcessCoordinationUnit_ParamsDataView() {}

  CoordinationUnitProvider_CreateProcessCoordinationUnit_ParamsDataView(
      internal::CoordinationUnitProvider_CreateProcessCoordinationUnit_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeRequest() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::resource_coordinator::mojom::ProcessCoordinationUnitRequestDataView>(
            &data_->request, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetIdDataView(
      ::resource_coordinator::mojom::CoordinationUnitIDDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadId(UserType* output) {
    auto* pointer = data_->id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
        pointer, output, context_);
  }
 private:
  internal::CoordinationUnitProvider_CreateProcessCoordinationUnit_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class CoordinationUnitProvider_GetSystemCoordinationUnit_ParamsDataView {
 public:
  CoordinationUnitProvider_GetSystemCoordinationUnit_ParamsDataView() {}

  CoordinationUnitProvider_GetSystemCoordinationUnit_ParamsDataView(
      internal::CoordinationUnitProvider_GetSystemCoordinationUnit_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeRequest() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::resource_coordinator::mojom::SystemCoordinationUnitRequestDataView>(
            &data_->request, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::CoordinationUnitProvider_GetSystemCoordinationUnit_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};


inline void CoordinationUnitProvider_CreateFrameCoordinationUnit_ParamsDataView::GetIdDataView(
    ::resource_coordinator::mojom::CoordinationUnitIDDataView* output) {
  auto pointer = data_->id.Get();
  *output = ::resource_coordinator::mojom::CoordinationUnitIDDataView(pointer, context_);
}


inline void CoordinationUnitProvider_CreatePageCoordinationUnit_ParamsDataView::GetIdDataView(
    ::resource_coordinator::mojom::CoordinationUnitIDDataView* output) {
  auto pointer = data_->id.Get();
  *output = ::resource_coordinator::mojom::CoordinationUnitIDDataView(pointer, context_);
}


inline void CoordinationUnitProvider_CreateProcessCoordinationUnit_ParamsDataView::GetIdDataView(
    ::resource_coordinator::mojom::CoordinationUnitIDDataView* output) {
  auto pointer = data_->id.Get();
  *output = ::resource_coordinator::mojom::CoordinationUnitIDDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace resource_coordinator

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_PROVIDER_MOJOM_PARAMS_DATA_H_